/*-----------------------------------------------------------------------

File  : clb_123trees.h

Author: Stephan Schulz

Contents
 
  Experimental new data structure for managing pointer sets.

Changes

<1> Tue Jan 26 16:00:37 MET 1999
    New

-----------------------------------------------------------------------*/

#ifndef CLB_123TREES

#define CLB_123TREES

#include <clb_ptrees.h>


/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/

#define X123ENTRY_NO 5 /* Has to be odd and >=3 ! */

typedef struct tree123_cell
{
   bool      is_son[X123ENTRY_NO]; /* This will be mashed into one word after
				      debugging */
   bool      full;                 /* All slots in this cell are
				      filled */
   void      *entry[X123ENTRY_NO]; /* I know, I know....void* is ugly,
				      but the only portable way */
}X123TreeCell, *X123Tree_p;



/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

#define X123TreeCellAlloc()    (X123TreeCell*)SizeMalloc(sizeof(X123TreeCell))
#define X123TreeCellFree(junk) SizeFree(junk, sizeof(X123TreeCell))

#define X123EntryIsSon(cell, index)  ((cell)->is_son[(index)])
#define X123EntrySetSon(cell, index) (((cell)->is_son[(index)])=true)
#define X123EntryDelSon(cell, index) (((cell)->is_son[(index)])=false)

#define X123CellIsFull(cell)  ((cell)->full)
#define X123CellSetFull(cell) (cell)->full = true
#define X123CellDelFull(cell) (cell)->full = false


X123Tree_p X123TreeCellAllocEmpty();
void       X123TreeFree(X123Tree_p junk);
bool       X123TreeStore(X123Tree_p *root, void* key);
X123Tree_p X123TreeFind(X123Tree_p root, void* key);
void*      X123TreeExtractKey(X123Tree_p *root, void* key);
bool       X123TreeDeleteEntry(X123Tree_p *root, void* key);
void       X123TreeMerge(X123Tree_p *root, X123Tree_p add);
long       X123TreeNodes(X123Tree_p root);


#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





