/*-----------------------------------------------------------------------

File  : clb_partial_orderings.h

Author: Stephan Schulz

Contents
 
  Functions and datatypes useful in dealing with partial orderings.

  Copyright 1998, 1999 by the author.
  This code is released under the GNU General Public Licence.
  See the file COPYING in the main CLIB directory for details.
  Run "eprover -h" for contact information.

Changes

<1> Wed Jun 16 22:37:09 MET DST 1999
    New

-----------------------------------------------------------------------*/

#ifndef CLB_PARTIAL_ORDERINGS

#define CLB_PARTIAL_ORDERINGS

#include <clb_defines.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/


/* Possible results of partial ordering comparisons */

typedef enum
{
   to_uncomparable,
   to_equal,
   to_greater,
   to_lesser
}CompareResult;



/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

extern char*  TOCompareSymbol[];

/* Translating standard UNIX total Quasi-Ordering comparions into
   CompareResult: */

#define Q_TO_PART(res) (((res)<0) ? to_lesser:\
                       (((res)>0) ? to_greater:to_equal))





#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





